.data
BN_SIZE_EXPAND equ 4;  1 extra bit (montgomery) 
align dword
BN_ALLOC_BYTES	dd ((BN_DEFAULT_BITS/08)*BN_SIZE_EXPAND)+BN.dwArray
BN_MAX_DWORD	dd ((BN_DEFAULT_BITS/32)*BN_SIZE_EXPAND)

.code
_a_
bn_error proc pText:DWORD
	IFDEF DEBUG
	invoke MessageBox,0,pText,0,MB_ICONERROR
	ELSE
	invoke RaiseException,0BADC0DEh,0,0,0
	ENDIF
	ret
bn_error endp
;
;	arg1 = bits 
;	sets the limit for further allocated bigs
;	must be your first function called
;	must free all bigs before calling again
;
_a_
bnInit proc MaxBits:DWORD
	mov eax,MaxBits
	and eax,03FFFh; limit
	add eax,31
	and eax,-32; align 32
	mov edx,eax
	shr edx,3; bytes
	shr eax,5; dwords
	shl edx,BN_SIZE_EXPAND/2; BN_SIZE_EXPAND is 2 or 4 
	shl eax,BN_SIZE_EXPAND/2
	add edx,BN.dwArray; place for size & sign 
	mov BN_MAX_DWORD,eax
	mov BN_ALLOC_BYTES,edx
	ret
bnInit endp
;
; unused
;
_a_
bnFinish proc
	ret
bnFinish endp
;
;	returns a bn (initialized to 0)
;	
_a_
bnCreate proc ; return in eax
	invoke GetProcessHeap
	invoke HeapAlloc,eax,HEAP_GENERATE_EXCEPTIONS+HEAP_ZERO_MEMORY,BN_ALLOC_BYTES
	.if eax
		mov [eax].BN.dwSize,1
		ret
	.endif
	IFDEF DEBUG
	invoke bn_error,T('alloc')
	ELSE
	invoke bn_error,0
	ENDIF
	ret
bnCreate endp
;
;	arg1 = integer
;	returns a bn
;	specify a sdword for initialization
;
_a_
bnCreatei proc initVal:SDWORD
	invoke GetProcessHeap
	invoke HeapAlloc,eax,HEAP_GENERATE_EXCEPTIONS+HEAP_ZERO_MEMORY,BN_ALLOC_BYTES
	.if eax
		mov edx,initVal
		mov [eax].BN.dwSize,1
		mov [eax].BN.dwArray[0*4],edx
		ret
	.endif
	IFDEF DEBUG
	invoke bn_error,T('alloc')
	ELSE
	invoke bn_error,0
	ENDIF
	ret
bnCreatei endp
;
;	arg1 = bn
;	free bn memory
;
_a_
bnDestroy proc bn:DWORD
	invoke GetProcessHeap
	invoke HeapFree,eax,HEAP_GENERATE_EXCEPTIONS+HEAP_ZERO_MEMORY,bn
	.if eax
		ret
	.endif
	IFDEF DEBUG
	invoke bn_error,T('bn not created?')
	ELSE
	invoke bn_error,0
	ENDIF
	ret
bnDestroy endp
;
;	arg1 = bn
;	set bn to 0
;
_a_ 
bnClear proc uses edi bn:DWORD
	mov edi,bn  
	xor eax,eax
	mov [edi].BN.dwSize,1
	mov [edi].BN.bSigned,eax;FALSE
	mov ecx,BN_MAX_DWORD
	lea edi,[edi].BN.dwArray
	rep stosd;clear the num
	ret
bnClear endp
;
;	arg1 = bn
;	returns number of bits in a bn
;	
_a_
bnBits proc bn:dword
	; Agner - emulates BSR
	mov edx,bn
	mov ecx,[edx].BN.dwSize
	mov eax,[edx].BN.dwArray[ecx*4-4]
	push 0
	push eax
	fild qword ptr [esp]
	shl ecx,5
	fstp qword ptr [esp]
	mov eax,[esp+4]
	add esp,8
	shr eax,20   ; isolate exponent
	jz @F
	sub eax,3FEh ; adjust
	lea eax,[eax+ecx-32]
@@:
	
	; Is it really faster?
	
	ret
bnBits endp
;
;	m2m
;
_a_
bnMov proc bn_Dest:DWORD,bn_Src:DWORD
	mov edx,edi
	mov eax,esi
	mov edi,bn_Dest
	mov ecx,BN_ALLOC_BYTES
	mov esi,bn_Src 
	shr ecx,2
	rep movsd
	mov esi,eax
	mov edi,edx
	ret 
bnMov endp
;
;	dword into bignum
;
_a_
bnMovzx proc uses edi bn:DWORD, dwVal:DWORD
	mov edi,bn  
	mov ecx,BN_ALLOC_BYTES
	xor eax,eax
	shr ecx,2
	rep stosd
	mov edi,bn
	inc eax
	mov ecx,dwVal
	mov [edi].BN.dwSize,eax;set size to 1
	;mov [edi].BN.bSigned,FALSE
	mov [edi].BN.dwArray[0*4],ecx;init it with val
	ret
bnMovzx endp
;
;	sdword into bignum
;	
_a_
bnMovsx proc uses edi bn:DWORD, dwVal:SDWORD
	mov edi,bn  
	mov ecx,BN_ALLOC_BYTES
	mov edx,dwVal
	xor eax,eax
	shr ecx,2
	rep stosd
	inc eax
	mov edi,bn
	test edx,edx
	sets byte ptr [edi].BN.bSigned
	.if sign?
		neg edx
	.endif
	mov [edi].BN.dwSize,eax
	mov [edi].BN.dwArray[0*4],edx;init it with val
	ret
bnMovsx endp
;
;	0 if X=Y      1 if X>Y      -1 if X<Y
;
_a_
bnCmp proc uses edi esi ebx bnX:DWORD, bnY:DWORD
	mov edi,bnX
	mov esi,bnY
	mov eax,[edi].BN.bSigned
	mov ebx,[esi].BN.bSigned
	mov edx,[edi].BN.dwSize
	mov ecx,[esi].BN.dwSize
	.if eax == ebx
		lea eax,[edx+1]; i = size + 1
		jmp @@Cmp
		.repeat
			dec eax
			jz @F; done, equal
			mov edx,[edi].BN.dwArray[eax*4-4];bnX[i]
			mov ecx,[esi].BN.dwArray[eax*4-4];bnY[i]
@@Cmp:	.until edx != ecx
		xor eax,eax
		.if edx > ecx
			inc eax
		.else
			dec eax
		.endif
		.if ebx; if -,- else +,+
			neg eax 
		.endif
	@@:	ret
	.else
		.if ebx; +,-
			inc eax
		.else; -,+
			or eax,-1
		.endif
	.endif
	ret
bnCmp endp
;
;	exchange x,y
;	
_a_
bnXchg proc uses esi edi bnX:DWORD, bnY:DWORD
	mov ecx,BN_ALLOC_BYTES
	mov edi,bnX
	shr ecx,2
	mov esi,bnY 
	.repeat
		mov eax,[esi+ecx*4]
		mov edx,[edi+ecx*4]
		mov [edi+ecx*4],eax
		mov [esi+ecx*4],edx
		dec ecx
	.until sign?
	ret 
bnXchg endp

